Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxscrinit.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxscrinit.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxscrinit.c
@@ -233,120 +1049,213 @@ Bool dmxScreenInit(int idx, ScreenPtr pS
      * Maybe a miAddVisualTypeAndMask() function will be added to make
      * things easier here.
      */
-    for (i = 0; i < dmxScreen->beNumDepths; i++) {
-	int    depth;
-	int    visuals        = 0;
-	int    bitsPerRgb     = 0;
-	int    preferredClass = -1;
-	Pixel  redMask        = 0;
-	Pixel  greenMask      = 0;
-	Pixel  blueMask       = 0;
-
-	depth = dmxScreen->beDepths[i];
-	for (j = 0; j < dmxScreen->beNumVisuals; j++) {
-	    XVisualInfo *vi;
-
-	    vi = &dmxScreen->beVisuals[j];
-	    if (vi->depth == depth) {
-		/* Assume the masks are all the same. */
-		visuals |= (1 << vi->class);
-		bitsPerRgb = vi->bits_per_rgb;
-		redMask = vi->red_mask;
-		greenMask = vi->green_mask;
-		blueMask = vi->blue_mask;
-		if (j == dmxScreen->beDefVisualIndex) {
-		    preferredClass = vi->class;
+    if (dmxScreen->beAttachedDisplay)
+    {
+	for (i = 0; i < dmxScreen->beNumDepths; i++) {
+	    int    depth;
+	    int    visuals        = 0;
+	    int    bitsPerRgb     = 0;
+	    int    preferredClass = -1;
+	    Pixel  redMask        = 0;
+	    Pixel  greenMask      = 0;
+	    Pixel  blueMask       = 0;
+
+	    depth = dmxScreen->beDepths[i];
+	    for (j = 0; j < dmxScreen->beNumVisuals; j++) {
+		XVisualInfo *vi;
+
+		vi = &dmxScreen->beVisuals[j];
+		if (vi->depth == depth) {
+		    /* Assume the masks are all the same. */
+		    visuals |= (1 << vi->class);
+		    bitsPerRgb = vi->bits_per_rgb;
+		    redMask = vi->red_mask;
+		    greenMask = vi->green_mask;
+		    blueMask = vi->blue_mask;
+		    if (j == dmxScreen->beDefVisualIndex) {
+			preferredClass = vi->class;
+		    }
+		}
+	    }
+
+#ifdef PANORAMIX
+	    if (!noPanoramiXExtension)
+	    {
+		/* avoid additional DirectColor visuals for better
+		   back-end server support */
+		if (preferredClass != DirectColor)
+		    visuals &= ~(1 << DirectColor);
+	    }
+#endif
+
+	    miSetVisualTypesAndMasks(depth, visuals, bitsPerRgb,
+				     preferredClass,
+				     redMask, greenMask, blueMask);
+	}
+    }
+    else
+    {
+	for (i = 0; i < dmxScreens[0].beNumDepths; i++) {
+	    int    depth;
+	    int    visuals        = 0;
+	    int    bitsPerRgb     = 0;
+	    int    preferredClass = -1;
+	    Pixel  redMask        = 0;
+	    Pixel  greenMask      = 0;
+	    Pixel  blueMask       = 0;
+
+	    depth = dmxScreens[0].beDepths[i];
+	    for (j = 0; j < dmxScreens[0].beNumVisuals; j++) {
+		XVisualInfo *vi;
+
+		vi = &dmxScreens[0].beVisuals[j];
+		if (vi->depth == depth) {
+		    /* Assume the masks are all the same. */
+		    visuals |= (1 << vi->class);
+		    bitsPerRgb = vi->bits_per_rgb;
+		    redMask = vi->red_mask;
+		    greenMask = vi->green_mask;
+		    blueMask = vi->blue_mask;
+		    if (j == dmxScreens[0].beDefVisualIndex) {
+			preferredClass = vi->class;
+		    }
 		}
 	    }
+
+#ifdef PANORAMIX
+	    if (!noPanoramiXExtension)
+	    {
+		/* avoid additional DirectColor visuals for better
+		   back-end server support */
+		if (preferredClass != DirectColor)
+		    visuals &= ~(1 << DirectColor);
+	    }
+#endif
+
+	    miSetVisualTypesAndMasks(depth, visuals, bitsPerRgb,
+				     preferredClass,
+				     redMask, greenMask, blueMask);
 	}
-	miSetVisualTypesAndMasks(depth, visuals, bitsPerRgb, preferredClass,
-				 redMask, greenMask, blueMask);
     }
 
     fbScreenInit(pScreen,
-		 dmxShadowFB ? dmxScreen->shadow : NULL,
+		 NULL,
 		 dmxScreen->scrnWidth,
 		 dmxScreen->scrnHeight,
 		 dmxScreen->beXDPI,
-		 dmxScreen->beXDPI,
+		 dmxScreen->beYDPI,
 		 dmxScreen->scrnWidth,
 		 dmxScreen->beBPP);
+
+    if (!dmxScreen->scrnWin && dmxScreen->beDisplay)
+    {
+	dmxScreen->scrnWin = DefaultRootWindow (dmxScreen->beDisplay);
+	dmxScreen->scrnEventMask |= StructureNotifyMask;
+	XSelectInput (dmxScreen->beDisplay,
+		      dmxScreen->scrnWin,
+		      dmxScreen->scrnEventMask);
+    }
+
+#ifdef MITSHM
+    ShmRegisterDmxFuncs (pScreen);
+#endif
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	for (i = 0; i < pScreen->numVisuals; i++)
+	    if (pScreen->visuals[i].ColormapEntries > 256)
+		pScreen->visuals[i].ColormapEntries = 256;
+    }
+#endif
+
 #ifdef RENDER
-    (void)dmxPictureInit(pScreen, 0, 0);
+    if (!dmxPictureInit (pScreen, 0, 0))
+	return FALSE;
 #endif
 
-    if (dmxShadowFB && !shadowInit(pScreen, dmxShadowUpdateProc, NULL))
+#ifdef RANDR
+    if (!dmxRRScreenInit (pScreen))
+	return FALSE;
+#endif
+
+#ifdef XV
+    if (!dmxXvScreenInit (pScreen))
+	return FALSE;
+#endif
+
+    if (!dmxDnDScreenInit (pScreen))
 	return FALSE;
 
     miInitializeBackingStore(pScreen);
 
-    if (dmxShadowFB) {
-	miDCInitialize(pScreen, &dmxPointerCursorFuncs);
-    } else {
-        MAXSCREENSALLOC(dmxCursorGeneration);
-	if (dmxCursorGeneration[idx] != serverGeneration) {
-	    if (!(miPointerInitialize(pScreen,
-				      &dmxPointerSpriteFuncs,
-				      &dmxPointerCursorFuncs,
-				      FALSE)))
-		return FALSE;
+    MAXSCREENSALLOC(dmxCursorGeneration);
+    if (dmxCursorGeneration[idx] != serverGeneration) {
+	if (!(miPointerInitialize(pScreen,
+				  &dmxPointerSpriteFuncs,
+				  &dmxPointerCursorFuncs,
+				  FALSE)))
+	    return FALSE;
 
-	    dmxCursorGeneration[idx] = serverGeneration;
-	}
+	dmxCursorGeneration[idx] = serverGeneration;
     }
 
     DMX_WRAP(CloseScreen, dmxCloseScreen, dmxScreen, pScreen);
     DMX_WRAP(SaveScreen, dmxSaveScreen, dmxScreen, pScreen);
 
-    dmxBEScreenInit(idx, pScreen);
+    /* Wrap GC functions */
+    DMX_WRAP(CreateGC, dmxCreateGC, dmxScreen, pScreen);
 
-    if (!dmxShadowFB) {
-	/* Wrap GC functions */
-	DMX_WRAP(CreateGC, dmxCreateGC, dmxScreen, pScreen);
-
-	/* Wrap Window functions */
-	DMX_WRAP(CreateWindow, dmxCreateWindow, dmxScreen, pScreen);
-	DMX_WRAP(DestroyWindow, dmxDestroyWindow, dmxScreen, pScreen);
-	DMX_WRAP(PositionWindow, dmxPositionWindow, dmxScreen, pScreen);
-	DMX_WRAP(ChangeWindowAttributes, dmxChangeWindowAttributes, dmxScreen,
-		 pScreen);
-	DMX_WRAP(RealizeWindow, dmxRealizeWindow, dmxScreen, pScreen);
-	DMX_WRAP(UnrealizeWindow, dmxUnrealizeWindow, dmxScreen, pScreen);
-	DMX_WRAP(RestackWindow, dmxRestackWindow, dmxScreen, pScreen);
-	DMX_WRAP(WindowExposures, dmxWindowExposures, dmxScreen, pScreen);
-	DMX_WRAP(CopyWindow, dmxCopyWindow, dmxScreen, pScreen);
-
-	DMX_WRAP(ResizeWindow, dmxResizeWindow, dmxScreen, pScreen);
-	DMX_WRAP(ReparentWindow, dmxReparentWindow, dmxScreen, pScreen);
-
-	DMX_WRAP(ChangeBorderWidth, dmxChangeBorderWidth, dmxScreen, pScreen);
-
-	/* Wrap Image functions */
-	DMX_WRAP(GetImage, dmxGetImage, dmxScreen, pScreen);
-	DMX_WRAP(GetSpans, dmxGetSpans, dmxScreen, pScreen);
-
-	/* Wrap Pixmap functions */
-	DMX_WRAP(CreatePixmap, dmxCreatePixmap, dmxScreen, pScreen);
-	DMX_WRAP(DestroyPixmap, dmxDestroyPixmap, dmxScreen, pScreen);
-	DMX_WRAP(BitmapToRegion, dmxBitmapToRegion, dmxScreen, pScreen);
-
-	/* Wrap Font functions */
-	DMX_WRAP(RealizeFont, dmxRealizeFont, dmxScreen, pScreen);
-	DMX_WRAP(UnrealizeFont, dmxUnrealizeFont, dmxScreen, pScreen);
-
-	/* Wrap Colormap functions */
-	DMX_WRAP(CreateColormap, dmxCreateColormap, dmxScreen, pScreen);
-	DMX_WRAP(DestroyColormap, dmxDestroyColormap, dmxScreen, pScreen);
-	DMX_WRAP(InstallColormap, dmxInstallColormap, dmxScreen, pScreen);
-	DMX_WRAP(StoreColors, dmxStoreColors, dmxScreen, pScreen);
+    /* Wrap Window functions */
+    DMX_WRAP(CreateWindow, dmxCreateWindow, dmxScreen, pScreen);
+    DMX_WRAP(DestroyWindow, dmxDestroyWindow, dmxScreen, pScreen);
+    DMX_WRAP(PositionWindow, dmxPositionWindow, dmxScreen, pScreen);
+    DMX_WRAP(ChangeWindowAttributes, dmxChangeWindowAttributes, dmxScreen,
+	     pScreen);
+    DMX_WRAP(RealizeWindow, dmxRealizeWindow, dmxScreen, pScreen);
+    DMX_WRAP(UnrealizeWindow, dmxUnrealizeWindow, dmxScreen, pScreen);
+    DMX_WRAP(RestackWindow, dmxRestackWindow, dmxScreen, pScreen);
+    DMX_WRAP(CopyWindow, dmxCopyWindow, dmxScreen, pScreen);
+
+    DMX_WRAP(ResizeWindow, dmxResizeWindow, dmxScreen, pScreen);
+    DMX_WRAP(HandleExposures, dmxHandleExposures, dmxScreen, pScreen);
+    DMX_WRAP(ReparentWindow, dmxReparentWindow, dmxScreen, pScreen);
+
+    DMX_WRAP(ChangeBorderWidth, dmxChangeBorderWidth, dmxScreen, pScreen);
+
+    DMX_WRAP(ModifyPixmapHeader, dmxModifyPixmapHeader, dmxScreen, pScreen);
+
+    DMX_WRAP(SetWindowPixmap, dmxSetWindowPixmap, dmxScreen, pScreen);
+
+    /* Wrap Image functions */
+    DMX_WRAP(GetImage, dmxGetImage, dmxScreen, pScreen);
+    DMX_WRAP(GetSpans, NULL, dmxScreen, pScreen);
+
+    /* Wrap Pixmap functions */
+    DMX_WRAP(CreatePixmap, dmxCreatePixmap, dmxScreen, pScreen);
+    DMX_WRAP(DestroyPixmap, dmxDestroyPixmap, dmxScreen, pScreen);
+    DMX_WRAP(BitmapToRegion, dmxBitmapToRegion, dmxScreen, pScreen);
+
+    /* Wrap Font functions */
+    DMX_WRAP(RealizeFont, dmxRealizeFont, dmxScreen, pScreen);
+    DMX_WRAP(UnrealizeFont, dmxUnrealizeFont, dmxScreen, pScreen);
+
+    /* Wrap Colormap functions */
+    DMX_WRAP(CreateColormap, dmxCreateColormap, dmxScreen, pScreen);
+    DMX_WRAP(DestroyColormap, dmxDestroyColormap, dmxScreen, pScreen);
+    DMX_WRAP(InstallColormap, dmxInstallColormap, dmxScreen, pScreen);
+    DMX_WRAP(StoreColors, dmxStoreColors, dmxScreen, pScreen);
 
-	/* Wrap Shape functions */
-	DMX_WRAP(SetShape, dmxSetShape, dmxScreen, pScreen);
-    }
+    /* Wrap Shape functions */
+    DMX_WRAP(SetShape, dmxSetShape, dmxScreen, pScreen);
 
     if (!dmxCreateDefColormap(pScreen))
 	return FALSE;
 
+    RegisterBlockAndWakeupHandlers (dmxScreenBlockHandler,
+				    dmxScreenWakeupHandler,
+				    pScreen);
+
     return TRUE;
 }
 
@@ -356,51 +1265,38 @@ void dmxBECloseScreen(ScreenPtr pScreen)
     DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
     int            i;
 
-    /* Restore the back-end screen-saver and DPMS state. */
-    dmxDPMSTerm(dmxScreen);
+#ifdef XV
+    dmxBEXvScreenFini (pScreen);
+#endif
 
-    /* Free the screen resources */
+#ifdef RANDR
+    dmxBERRScreenFini (pScreen);
+#endif
 
-    XFreeCursor(dmxScreen->beDisplay, dmxScreen->noCursor);
-    dmxScreen->noCursor = (Cursor)0;
+    /* Restore the back-end screen-saver and DPMS state. */
+    dmxBEDPMSScreenFini (pScreen);
 
-    XUnmapWindow(dmxScreen->beDisplay, dmxScreen->scrnWin);
-    XDestroyWindow(dmxScreen->beDisplay, dmxScreen->scrnWin);
+    /* Free the screen resources */
     dmxScreen->scrnWin = (Window)0;
 
-    if (dmxShadowFB) {
-	/* Free the shadow GC and image assocated with the back-end server */
-	XFreeGC(dmxScreen->beDisplay, dmxScreen->shadowGC);
-	dmxScreen->shadowGC = NULL;
-	XFree(dmxScreen->shadowFBImage);
-	dmxScreen->shadowFBImage = NULL;
-    } else {
-	/* Free the default drawables */
-	for (i = 0; i < dmxScreen->beNumPixmapFormats; i++) {
-	    XFreePixmap(dmxScreen->beDisplay, dmxScreen->scrnDefDrawables[i]);
-	    dmxScreen->scrnDefDrawables[i] = (Drawable)0;
-	}
+    /* Free the default drawables */
+    for (i = 0; i < dmxScreen->beNumPixmapFormats; i++) {
+	XLIB_PROLOGUE (dmxScreen);
+	XFreePixmap(dmxScreen->beDisplay, dmxScreen->scrnDefDrawables[i]);
+	XLIB_EPILOGUE (dmxScreen);
+	dmxScreen->scrnDefDrawables[i] = (Drawable)0;
     }
 
     /* Free resources allocated during initialization (in dmxinit.c) */
     for (i = 0; i < dmxScreen->beNumDefColormaps; i++)
+    {
+	XLIB_PROLOGUE (dmxScreen);
 	XFreeColormap(dmxScreen->beDisplay, dmxScreen->beDefColormaps[i]);
+	XLIB_EPILOGUE (dmxScreen);
+    }
     xfree(dmxScreen->beDefColormaps);
     dmxScreen->beDefColormaps = NULL;
 
-#if 0
-    /* Do not free visuals, depths and pixmap formats here.  Free them
-     * in dmxCloseScreen() instead -- see comment below. */
-    XFree(dmxScreen->beVisuals);
-    dmxScreen->beVisuals = NULL;
-
-    XFree(dmxScreen->beDepths);
-    dmxScreen->beDepths = NULL;
-
-    XFree(dmxScreen->bePixmapFormats);
-    dmxScreen->bePixmapFormats = NULL;
-#endif
-
 #ifdef GLXEXT
     if (dmxScreen->glxVisuals) {
 	XFree(dmxScreen->glxVisuals);
@@ -409,9 +1305,8 @@ void dmxBECloseScreen(ScreenPtr pScreen)
     }
 #endif
 
-    /* Close display */
-    XCloseDisplay(dmxScreen->beDisplay);
-    dmxScreen->beDisplay = NULL;
+    dmxClearQueue (&dmxScreen->request);
+    dmxClearQueue (&dmxScreen->ignore);
 }
 
 /** Close screen number \a idx. */
@@ -419,62 +1314,78 @@ Bool dmxCloseScreen(int idx, ScreenPtr p
 {
     DMXScreenInfo *dmxScreen = &dmxScreens[idx];
 
+        /* Free input overlay window tree */
+    if (dmxScreen->inputOverlayWid)
+	FreeResource (dmxScreen->inputOverlayWid, RT_NONE);
+
     /* Reset the proc vectors */
     if (idx == 0) {
+#ifdef COMPOSITE
+	if (!noCompositeExtension)
+	    dmxResetComposite();
+#endif
 #ifdef RENDER
-	dmxResetRender();
+	if (!noRenderExtension)
+	    dmxResetRender();
 #endif
-	dmxResetFonts();
+#ifdef MITSHM
+	dmxResetShm();
+#endif
+	dmxResetInput ();
+	dmxResetSelections();
+	dmxResetGrabs();
+	dmxResetProps();
     }
 
-    if (dmxShadowFB) {
-	/* Free the shadow framebuffer */
-	xfree(dmxScreen->shadow);
-    } else {
+    /* Unwrap Shape functions */
+    DMX_UNWRAP(SetShape, dmxScreen, pScreen);
 
-	/* Unwrap Shape functions */
-	DMX_UNWRAP(SetShape, dmxScreen, pScreen);
+    /* Unwrap the pScreen functions */
+    DMX_UNWRAP(CreateGC, dmxScreen, pScreen);
 
-	/* Unwrap the pScreen functions */
-	DMX_UNWRAP(CreateGC, dmxScreen, pScreen);
+    DMX_UNWRAP(CreateWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(DestroyWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(PositionWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(ChangeWindowAttributes, dmxScreen, pScreen);
+    DMX_UNWRAP(RealizeWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(UnrealizeWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(RestackWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(CopyWindow, dmxScreen, pScreen);
 
-	DMX_UNWRAP(CreateWindow, dmxScreen, pScreen);
-	DMX_UNWRAP(DestroyWindow, dmxScreen, pScreen);
-	DMX_UNWRAP(PositionWindow, dmxScreen, pScreen);
-	DMX_UNWRAP(ChangeWindowAttributes, dmxScreen, pScreen);
-	DMX_UNWRAP(RealizeWindow, dmxScreen, pScreen);
-	DMX_UNWRAP(UnrealizeWindow, dmxScreen, pScreen);
-	DMX_UNWRAP(RestackWindow, dmxScreen, pScreen);
-	DMX_UNWRAP(WindowExposures, dmxScreen, pScreen);
-	DMX_UNWRAP(CopyWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(ResizeWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(HandleExposures, dmxScreen, pScreen);
+    DMX_UNWRAP(ReparentWindow, dmxScreen, pScreen);
 
-	DMX_UNWRAP(ResizeWindow, dmxScreen, pScreen);
-	DMX_UNWRAP(ReparentWindow, dmxScreen, pScreen);
+    DMX_UNWRAP(ChangeBorderWidth, dmxScreen, pScreen);
 
-	DMX_UNWRAP(ChangeBorderWidth, dmxScreen, pScreen);
+    DMX_UNWRAP(ModifyPixmapHeader, dmxScreen, pScreen);
 
-	DMX_UNWRAP(GetImage, dmxScreen, pScreen);
-	DMX_UNWRAP(GetSpans, dmxScreen, pScreen);
+    DMX_UNWRAP(SetWindowPixmap, dmxScreen, pScreen);
 
-	DMX_UNWRAP(CreatePixmap, dmxScreen, pScreen);
-	DMX_UNWRAP(DestroyPixmap, dmxScreen, pScreen);
-	DMX_UNWRAP(BitmapToRegion, dmxScreen, pScreen);
+    DMX_UNWRAP(GetImage, dmxScreen, pScreen);
+    DMX_UNWRAP(GetSpans, dmxScreen, pScreen);
 
-	DMX_UNWRAP(RealizeFont, dmxScreen, pScreen);
-	DMX_UNWRAP(UnrealizeFont, dmxScreen, pScreen);
+    DMX_UNWRAP(CreatePixmap, dmxScreen, pScreen);
+    DMX_UNWRAP(DestroyPixmap, dmxScreen, pScreen);
+    DMX_UNWRAP(BitmapToRegion, dmxScreen, pScreen);
 
-	DMX_UNWRAP(CreateColormap, dmxScreen, pScreen);
-	DMX_UNWRAP(DestroyColormap, dmxScreen, pScreen);
-	DMX_UNWRAP(InstallColormap, dmxScreen, pScreen);
-	DMX_UNWRAP(StoreColors, dmxScreen, pScreen);
-    }
+    DMX_UNWRAP(RealizeFont, dmxScreen, pScreen);
+    DMX_UNWRAP(UnrealizeFont, dmxScreen, pScreen);
+
+    DMX_UNWRAP(CreateColormap, dmxScreen, pScreen);
+    DMX_UNWRAP(DestroyColormap, dmxScreen, pScreen);
+    DMX_UNWRAP(InstallColormap, dmxScreen, pScreen);
+    DMX_UNWRAP(StoreColors, dmxScreen, pScreen);
 
     DMX_UNWRAP(SaveScreen, dmxScreen, pScreen);
 
     if (dmxScreen->beDisplay) {
 	dmxBECloseScreen(pScreen);
 
-#if 1
+	/* Close display */
+	dmxCloseDisplay (dmxScreen);
+	dmxScreen->beDisplay = NULL;
+
 	/* Free visuals, depths and pixmap formats here so that they
 	 * won't be freed when a screen is detached, thereby allowing
 	 * the screen to be reattached to be compared to the one
@@ -488,9 +1399,11 @@ Bool dmxCloseScreen(int idx, ScreenPtr p
 
 	XFree(dmxScreen->bePixmapFormats);
 	dmxScreen->bePixmapFormats = NULL;
-#endif
     }
 
+    if (idx == 0)
+	dmxAbortDisplay ();
+
     DMX_UNWRAP(CloseScreen, dmxScreen, pScreen);
     return pScreen->CloseScreen(idx, pScreen);
 }
@@ -500,15 +1413,21 @@ static Bool dmxSaveScreen(ScreenPtr pScr
     DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
 
     if (dmxScreen->beDisplay) {
+	if (dmxScreen->scrnWin != DefaultRootWindow (dmxScreen->beDisplay))
+	    return TRUE;
 	switch (what) {
 	case SCREEN_SAVER_OFF:
 	case SCREEN_SAVER_FORCER:
+	    XLIB_PROLOGUE (dmxScreen);
 	    XResetScreenSaver(dmxScreen->beDisplay);
+	    XLIB_EPILOGUE (dmxScreen);
 	    dmxSync(dmxScreen, FALSE);
 	    break;
 	case SCREEN_SAVER_ON:
 	case SCREEN_SAVER_CYCLE:
+	    XLIB_PROLOGUE (dmxScreen);
 	    XActivateScreenSaver(dmxScreen->beDisplay);
+	    XLIB_EPILOGUE (dmxScreen);
 	    dmxSync(dmxScreen, FALSE);
 	    break;
 	}
@@ -516,3 +1435,60 @@ static Bool dmxSaveScreen(ScreenPtr pScr
 
     return TRUE;
 }
+
+Bool
+dmxAddSequence (DMXQueue      *q,
+		unsigned long sequence)
+{
+    DMXSequence *s;
+
+    s = malloc (sizeof (DMXSequence));
+    if (!s)
+	return FALSE;
+
+    s->sequence = sequence;
+    s->next     = 0;
+
+    *(q->tail) = s;
+    q->tail = &s->next;
+
+    return TRUE;
+}
+
+void
+dmxClearQueue (DMXQueue *q)
+{
+    while (q->head)
+    {
+	DMXSequence *head = q->head;
+
+	q->head = head->next;
+	free (head);
+    }
+
+    q->tail = &q->head;
+}
+
+Bool
+dmxAddRequest (DMXQueue      *q,
+	       ReplyProcPtr  reply,
+	       unsigned long sequence,
+	       void          *data)
+{
+    DMXRequest *r;
+
+    r = malloc (sizeof (DMXRequest));
+    if (!r)
+	return FALSE;
+
+    r->base.sequence = sequence;
+    r->base.next     = 0;
+    r->reply         = reply;
+    r->data          = data;
+
+    *(q->tail) = &r->base;
+    q->tail = &r->base.next;
+
+    return TRUE;
+}
+
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxscrinit.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxscrinit.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxscrinit.h
@@ -45,7 +45,16 @@ extern DevPrivateKey dmxScreenPrivateKey
 
 extern Bool dmxScreenInit(int idx, ScreenPtr pScreen, int argc, char *argv[]);
 
-extern void dmxBEScreenInit(int idx, ScreenPtr pScreen);
+extern void dmxBEScreenInit(ScreenPtr pScreen);
 extern void dmxBECloseScreen(ScreenPtr pScreen);
+extern void dmxBEDispatch (ScreenPtr pScreen);
+
+extern Bool dmxAddSequence (DMXQueue *q, unsigned long sequence);
+extern void dmxClearQueue (DMXQueue *q);
+
+extern Bool dmxAddRequest (DMXQueue      *q,
+			   ReplyProcPtr  reply,
+			   unsigned long sequence,
+			   void          *data);
 
 #endif /* DMXSCRINIT_H */
